Index: tmp/org.txm.statsengine.r.rcp/src/org/txm/statsengine/r/rcp/handlers/ExecuteRScript.java
===================================================================
--- tmp/org.txm.statsengine.r.rcp/src/org/txm/statsengine/r/rcp/handlers/ExecuteRScript.java	(revision 686)
+++ tmp/org.txm.statsengine.r.rcp/src/org/txm/statsengine/r/rcp/handlers/ExecuteRScript.java	(revision 687)
@@ -49,9 +49,9 @@
 import org.eclipse.ui.ide.FileStoreEditorInput;
 import org.txm.core.preferences.TBXPreferences;
 import org.txm.core.preferences.TXMPreferences;
-import org.txm.rcp.RCPMessages;
 import org.txm.rcp.StatusLine;
 import org.txm.rcp.editors.TxtEditor;
+import org.txm.rcp.messages.TXMUIMessages;
 import org.txm.rcp.swt.dialog.LastOpened;
 import org.txm.statsengine.r.core.RWorkspace;
 import org.txm.statsengine.r.core.exceptions.RWorkspaceException;
@@ -130,7 +130,7 @@
 	public static void executeScript(String scriptfile) {
 		File rFile = new File(scriptfile);
 		if (!rFile.exists()) {
-			System.err.println(NLS.bind(RCPMessages.ExecuteScriptR_0, rFile));
+			System.err.println(NLS.bind(TXMUIMessages.ExecuteScriptR_0, rFile));
 			return;
 		}
 
@@ -144,7 +144,7 @@
 		boolean initState = rw.isLogging();
 		rw.setLog(true);
 		try {
-			System.out.println(NLS.bind(RCPMessages.ExecuteRScript_1, rFile.getName()));
+			System.out.println(NLS.bind(TXMUIMessages.ExecuteRScript_1, rFile.getName()));
 			long time = System.currentTimeMillis();
 			//execute a file line per line
 
@@ -173,10 +173,10 @@
 //				if (rw.isLogging() && str.length() > 0)
 //					RConsole.printServer(cmd);
 //			}
-			System.out.println(RCPMessages.ExecuteRScript_2+(System.currentTimeMillis()-time)+RCPMessages.ExecuteRScript_3);
+			System.out.println(TXMUIMessages.ExecuteRScript_2+(System.currentTimeMillis()-time)+TXMUIMessages.ExecuteRScript_3);
 		} catch(Exception e) {
-			System.out.println(NLS.bind(RCPMessages.ExecuteScriptR_1, rFile, e)); 
-			StatusLine.error(NLS.bind(RCPMessages.ExecuteScriptR_1, rFile, e)); 
+			System.out.println(NLS.bind(TXMUIMessages.ExecuteScriptR_1, rFile, e)); 
+			StatusLine.error(NLS.bind(TXMUIMessages.ExecuteScriptR_1, rFile, e)); 
 			Log.printStackTrace(e);
 		}
 
Index: tmp/org.txm.statsengine.r.rcp/src/org/txm/statsengine/r/rcp/handlers/ExecuteRText.java
===================================================================
--- tmp/org.txm.statsengine.r.rcp/src/org/txm/statsengine/r/rcp/handlers/ExecuteRText.java	(revision 686)
+++ tmp/org.txm.statsengine.r.rcp/src/org/txm/statsengine/r/rcp/handlers/ExecuteRText.java	(revision 687)
@@ -34,8 +34,8 @@
 import org.eclipse.jface.viewers.ISelection;
 import org.eclipse.osgi.util.NLS;
 import org.eclipse.ui.handlers.HandlerUtil;
-import org.txm.rcp.RCPMessages;
 import org.txm.rcp.StatusLine;
+import org.txm.rcp.messages.TXMUIMessages;
 import org.txm.statsengine.r.core.RWorkspace;
 import org.txm.statsengine.r.core.exceptions.RWorkspaceException;
 import org.txm.utils.logger.Log;
@@ -83,7 +83,7 @@
 		rw.setLog(true);
 
 		try {
-			System.out.println(RCPMessages.ExecuteRText_0);
+			System.out.println(TXMUIMessages.ExecuteRText_0);
 			long time = System.currentTimeMillis();
 			//execute a file line per line
 
@@ -93,10 +93,10 @@
 //				RConsole.printServer(str);
 			RWorkspace.appendtoEvalLog(text);
 
-			System.out.println(RCPMessages.ExecuteRScript_2+(System.currentTimeMillis()-time)+RCPMessages.ExecuteRText_2); 
+			System.out.println(TXMUIMessages.ExecuteRScript_2+(System.currentTimeMillis()-time)+TXMUIMessages.ExecuteRText_2); 
 		} catch(Exception e) {
-			System.out.println(NLS.bind(RCPMessages.ExecuteRText_1, text, Log.toString(e))); 
-			StatusLine.error(NLS.bind(RCPMessages.ExecuteRText_1, text, Log.toString(e))); 
+			System.out.println(NLS.bind(TXMUIMessages.ExecuteRText_1, text, Log.toString(e))); 
+			StatusLine.error(NLS.bind(TXMUIMessages.ExecuteRText_1, text, Log.toString(e))); 
 			org.txm.rcp.utils.Logger.printStackTrace(e);
 		}
 
Index: tmp/org.txm.statsengine.r.rcp/src/org/txm/statsengine/r/rcp/preferences/RPreferencePage.java
===================================================================
--- tmp/org.txm.statsengine.r.rcp/src/org/txm/statsengine/r/rcp/preferences/RPreferencePage.java	(revision 686)
+++ tmp/org.txm.statsengine.r.rcp/src/org/txm/statsengine/r/rcp/preferences/RPreferencePage.java	(revision 687)
@@ -35,9 +35,9 @@
 import org.eclipse.jface.util.PropertyChangeEvent;
 import org.eclipse.ui.IWorkbench;
 import org.txm.core.preferences.TXMPreferences;
+import org.txm.rcp.messages.TXMUIMessages;
 import org.txm.rcp.preferences.TXMPreferencePage;
 import org.txm.rcp.preferences.TXMPreferenceStore;
-import org.txm.rcp.RCPMessages;
 import org.txm.statsengine.r.core.RWorkspace;
 import org.txm.statsengine.r.core.preferences.RPreferences;
 import org.txm.statsengine.r.rcp.messages.RUIMessages;
@@ -200,7 +200,7 @@
 				RWorkspace.setUseFileCommunication(TXMPreferences.getBoolean(RPreferences.FILE_TRANSFERT, RPreferences.PREFERENCES_NODE));
 			}
 		} catch (Exception e) {
-			System.err.println(RCPMessages.FAILED_TO_SAVE_PREFERENCES + e);
+			System.err.println(TXMUIMessages.FAILED_TO_SAVE_PREFERENCES + e);
 		}
 		return true;
 	}
Index: tmp/org.txm.statsengine.r.rcp/src/org/txm/statsengine/r/rcp/views/RVariablesView.java
===================================================================
--- tmp/org.txm.statsengine.r.rcp/src/org/txm/statsengine/r/rcp/views/RVariablesView.java	(revision 686)
+++ tmp/org.txm.statsengine.r.rcp/src/org/txm/statsengine/r/rcp/views/RVariablesView.java	(revision 687)
@@ -60,7 +60,7 @@
 import org.eclipse.ui.part.ViewPart;
 import org.txm.Toolbox;
 import org.txm.ca.core.functions.CA;
-import org.txm.cah.core.functions.AHC;
+import org.txm.ahc.core.functions.AHC;
 import org.txm.concordance.core.functions.Concordance;
 import org.txm.cooccurrence.core.functions.Cooccurrence;
 import org.txm.core.results.TXMResult;
@@ -70,9 +70,9 @@
 import org.txm.objects.Base;
 import org.txm.progression.core.functions.Progression;
 import org.txm.rcp.IImageKeys;
-import org.txm.rcp.RCPMessages;
 import org.txm.rcp.commands.R.CopySelection;
 import org.txm.rcp.handlers.files.EditFile;
+import org.txm.rcp.messages.TXMUIMessages;
 import org.txm.referencer.core.functions.Referencer;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.corpus.Corpus;
@@ -231,7 +231,7 @@
 		Button export = new Button(parent, SWT.PUSH);
 		export.setLayoutData(new GridData(GridData.FILL, GridData.FILL, true,
 				false));
-		export.setText(RCPMessages.RVariablesView_1);
+		export.setText(TXMUIMessages.RVariablesView_1);
 		export.addSelectionListener(new SelectionListener() {
 			@Override
 			public void widgetSelected(SelectionEvent arg0) {
@@ -245,7 +245,7 @@
 		
 		Button logs = new Button(parent, SWT.PUSH);
 		logs.setLayoutData(new GridData(GridData.FILL, GridData.FILL, true,	false));
-		logs.setText(RCPMessages.RVariablesView_2);
+		logs.setText(TXMUIMessages.RVariablesView_2);
 		logs.addSelectionListener(new SelectionListener() {
 			@Override
 			public void widgetSelected(SelectionEvent arg0) {
@@ -346,7 +346,7 @@
 			if (symbol == null)
 				return name;
 			else
-				return NLS.bind(RCPMessages.RVariablesView_9, name, symbol);
+				return NLS.bind(TXMUIMessages.RVariablesView_9, name, symbol);
 		}
 
 		/* (non-Javadoc)
Index: tmp/org.txm.statsengine.r.rcp/src/org/txm/statsengine/r/rcp/views/RConsole.java
===================================================================
--- tmp/org.txm.statsengine.r.rcp/src/org/txm/statsengine/r/rcp/views/RConsole.java	(revision 686)
+++ tmp/org.txm.statsengine.r.rcp/src/org/txm/statsengine/r/rcp/views/RConsole.java	(revision 687)
@@ -41,7 +41,7 @@
 import org.txm.Toolbox;
 import org.txm.Toolbox;
 import org.txm.rcp.IImageKeys;
-import org.txm.rcp.RCPMessages;
+import org.txm.rcp.messages.TXMUIMessages;
 import org.txm.statsengine.r.core.RWorkspace;
 import org.txm.statsengine.r.core.exceptions.RWorkspaceException;
 import org.txm.utils.MessagePrinter;
@@ -231,7 +231,7 @@
 	public void connectToRWorkspace() {
 		if (!readyToDisplay && Toolbox.getEngineManager(EngineType.STAT).getEngine("R").getState()) {
 			RWorkspace rw = null;
-			Log.warning(RCPMessages.RConsole_0);
+			Log.warning(TXMUIMessages.RConsole_0);
 			try {
 				rw = RWorkspace.getRWorkspaceInstance();
 				if (rw == null) return;
@@ -246,7 +246,7 @@
 					readyToDisplay = true;
 				//}
 			} catch (RWorkspaceException e) {
-				System.out.println(RCPMessages.RConsole_1+e);
+				System.out.println(TXMUIMessages.RConsole_1+e);
 				Log.printStackTrace(e);
 			}
 		}
Index: tmp/org.txm.treetagger.rcp/META-INF/MANIFEST.MF
===================================================================
--- tmp/org.txm.treetagger.rcp/META-INF/MANIFEST.MF	(revision 686)
+++ tmp/org.txm.treetagger.rcp/META-INF/MANIFEST.MF	(revision 687)
@@ -1,10 +1,10 @@
 Manifest-Version: 1.0
 Bundle-ManifestVersion: 2
 Bundle-Name: TreeTagger
-Bundle-SymbolicName: TreeTagger;singleton:=true
+Bundle-SymbolicName: org.txm.treetagger.rcp;singleton:=true
 Bundle-Version: 1.0.0.qualifier
-Bundle-Activator: treetagger.Activator
 Require-Bundle: org.eclipse.ui,
+ org.txm.treetagger.core;bundle-version="1.0.0",
  org.eclipse.core.runtime,
  org.eclipse.swt,
  org.txm.core;bundle-version="0.7.0",
Index: tmp/org.txm.treetagger.rcp/src/org/txm/treetagger/rcp/handlers/Apply.java
===================================================================
--- tmp/org.txm.treetagger.rcp/src/org/txm/treetagger/rcp/handlers/Apply.java	(revision 0)
+++ tmp/org.txm.treetagger.rcp/src/org/txm/treetagger/rcp/handlers/Apply.java	(revision 687)
@@ -0,0 +1,123 @@
+package org.txm.treetagger.rcp.handlers;
+
+import java.io.File;
+import java.io.FileFilter;
+import java.util.Arrays;
+import java.util.HashMap;
+
+import org.eclipse.core.commands.AbstractHandler;
+import org.eclipse.core.commands.ExecutionEvent;
+import org.eclipse.core.commands.ExecutionException;
+import org.eclipse.core.runtime.IProgressMonitor;
+import org.eclipse.core.runtime.IStatus;
+import org.eclipse.core.runtime.Status;
+import org.eclipse.jface.viewers.ISelection;
+import org.eclipse.jface.viewers.IStructuredSelection;
+import org.eclipse.ui.IWorkbenchWindow;
+import org.eclipse.ui.handlers.HandlerUtil;
+import org.kohsuke.args4j.Option;
+import org.txm.rcp.commands.workspace.UpdateCorpus;
+import org.txm.rcp.swt.widget.parameters.ParametersDialog;
+import org.txm.rcp.utils.JobHandler;
+import org.txm.scripts.teitxm.Annotate;
+import org.txm.searchengine.cqp.corpus.Corpus;
+import org.txm.searchengine.cqp.corpus.MainCorpus;
+
+/**
+ * Our sample handler extends AbstractHandler, an IHandler base class.
+ * @see org.eclipse.core.commands.IHandler
+ * @see org.eclipse.core.commands.AbstractHandler
+ */
+public class Apply extends AbstractHandler {
+	
+	@Option(name="model", usage="Model file", widget="File", required=true, def="model.par")
+	public File model = null;
+	@Option(name="posProperty", usage="The pos property", widget="String", required=true, def="frpos")
+	public String posProperty = null;
+	@Option(name="lemmaProperty", usage="The lemma property", widget="String", required=true, def="frlemma")
+	public String lemmaProperty = null;
+	@Option(name="options", usage="TreeTagger supplementary options", widget="String", required=true, def="")
+	public String options = null;
+
+	/**
+	 * 
+	 */
+	public Object execute(ExecutionEvent event) throws ExecutionException {
+		Corpus corpus = null;
+		IWorkbenchWindow window = HandlerUtil.getActiveWorkbenchWindowChecked(event);
+		
+		ISelection isel = window.getActivePage().getSelection();
+		if (isel instanceof IStructuredSelection) {
+			IStructuredSelection sel = (IStructuredSelection)isel;
+			Object first = sel.getFirstElement();
+			if (first instanceof Corpus) {
+				corpus = (Corpus)first;
+				if (ParametersDialog.open(this)) {
+					apply(corpus, model, new String[]{posProperty, lemmaProperty}, options.split("  "));
+					return corpus;
+				}
+			}
+		}
+		
+		System.out.println("Wrong selection.");
+		return null;
+	}
+	
+	public static void apply(Corpus corpus, final File model, final String[] properties, final String[] options) {
+		final MainCorpus mainCorpus = corpus.getMainCorpus();
+		final File corpusBinaryDirectory = mainCorpus.getBaseDirectory();
+		final File txmDirectory = new File(corpusBinaryDirectory, "txm/"+mainCorpus.getName());
+		
+		if (!txmDirectory.exists()) {
+			System.out.println("Can't apply TreeTagger to a corpus with no XML-TXM files.");
+		}
+		
+		final File[] files = txmDirectory.listFiles(new FileFilter() {
+			@Override
+			public boolean accept(File file) {
+				return file.isFile() && file.canWrite() && file.getName().endsWith(".xml");
+			}
+		});
+		
+		if (files == null || files.length == 0) {
+			System.out.println("Can't apply TreeTagger to a corpus with no XML-TXM files in "+txmDirectory);
+		}
+		
+		String lang = model.getName();
+		if (!lang.endsWith(".par")) {
+			System.out.println("Model file name must ends with the '.par' extension");
+			return;
+		}
+		lang = lang.substring(0, lang.indexOf(".par"));
+		
+		final HashMap<String, String> hash = new HashMap<String, String>();
+		for (File txmFile : files) {
+			hash.put(txmFile.getName(), lang);
+		}
+			
+		for (int i = 0 ; i < properties.length ; i++) properties[i] = properties[i].trim(); 
+		
+		System.out.println("APPLY : "+model+" to "+corpus+" updating "+Arrays.toString(properties)+ " with options "+Arrays.toString(options));
+		JobHandler job = new JobHandler("Applying TreeTagger to "+corpus+" corpus.") {
+			@Override
+			protected IStatus run(IProgressMonitor monitor) {
+				this.runInit(monitor);
+				Annotate annotator = new Annotate();
+				annotator.setModelsDirectory(model.getParentFile());
+				annotator.setDebug();
+				if (!annotator.run(corpusBinaryDirectory, txmDirectory, hash, true, properties, options)) {
+					System.out.println("Fail to apply TreeTagger with "+txmDirectory+" files.");
+					return Status.CANCEL_STATUS;
+				}
+				System.out.println("Done. Updating corpus...");
+				
+				if (UpdateCorpus.update(mainCorpus) == null) {
+					System.out.println("Fail to update corpus indexes and editions.");
+				}
+				System.out.println("Done.");
+				return Status.OK_STATUS;//frppos
+			}
+		};
+		job.schedule();
+	}
+}

Index: tmp/org.txm.treetagger.rcp/src/org/txm/treetagger/rcp/handlers/LemmaProjection.java
===================================================================
--- tmp/org.txm.treetagger.rcp/src/org/txm/treetagger/rcp/handlers/LemmaProjection.java	(revision 0)
+++ tmp/org.txm.treetagger.rcp/src/org/txm/treetagger/rcp/handlers/LemmaProjection.java	(revision 687)
@@ -0,0 +1,289 @@
+package org.txm.treetagger.rcp.handlers;
+
+import java.io.BufferedReader;
+import java.io.File;
+import java.io.FileFilter;
+import java.io.PrintWriter;
+import java.util.Arrays;
+import java.util.Collections;
+import java.util.HashSet;
+import java.util.LinkedHashMap;
+import java.util.LinkedHashSet;
+
+import org.apache.commons.lang.StringUtils;
+import org.eclipse.core.commands.AbstractHandler;
+import org.eclipse.core.commands.ExecutionEvent;
+import org.eclipse.core.commands.ExecutionException;
+import org.eclipse.core.runtime.IProgressMonitor;
+import org.eclipse.core.runtime.IStatus;
+import org.eclipse.core.runtime.Status;
+import org.eclipse.jface.viewers.ISelection;
+import org.eclipse.jface.viewers.IStructuredSelection;
+import org.eclipse.ui.IWorkbenchWindow;
+import org.eclipse.ui.handlers.HandlerUtil;
+import org.kohsuke.args4j.Option;
+import org.txm.Toolbox;
+import org.txm.core.preferences.TBXPreferences;
+import org.txm.core.preferences.TXMPreferences;
+import org.txm.rcp.swt.widget.parameters.ParametersDialog;
+import org.txm.rcp.utils.JobHandler;
+import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
+import org.txm.searchengine.cqp.corpus.Corpus;
+import org.txm.searchengine.cqp.corpus.MainCorpus;
+import org.txm.searchengine.cqp.corpus.Property;
+import org.txm.stat.utils.ConsoleProgressBar;
+import org.txm.utils.DeleteDir;
+import org.txm.utils.io.FileCopy;
+import org.txm.utils.io.IOUtils;
+import org.txm.utils.Tuple;
+
+/**
+ * Our sample handler extends AbstractHandler, an IHandler base class.
+ * @see org.eclipse.core.commands.IHandler
+ * @see org.eclipse.core.commands.AbstractHandler
+ */
+public class LemmaProjection extends AbstractHandler {
+
+	protected static final String EXTRA = "extra";
+	@Option(name="dictionary", usage="TSV Dictionary file with form, msd, lemma, source columns", widget="File", required=true, def="frolex.tsv")
+	public File dictionary = null;
+	@Option(name="extrarules", usage="form+pos rules files", widget="File", required=false, def="extrarules.tsv")
+	public File extrarules = null;
+	@Option(name="posproperty", usage="The lexicon property to read", widget="String", required=true, def="frpos")
+	public String posproperty = null;
+	@Option(name="lemmaproperty", usage="The property to create/update in the corpus", widget="String", required=true, def="plemma")
+	public String lemmaproperty = null;
+	@Option(name="formAsLemmaPosList", usage="Pos values lemma exceptions", widget="String", required=false, def="NOMPro")
+	public String formAsLemmaPosList = null;
+	@Option(name="sourcePriorityList", usage="The property to create/update in the corpus", widget="String", required=true, def="TL")
+	public String sourcePriorityList = null;
+
+	/**
+	 * 
+	 */
+	public Object execute(ExecutionEvent event) throws ExecutionException {
+		Corpus corpus = null;
+		IWorkbenchWindow window = HandlerUtil.getActiveWorkbenchWindowChecked(event);
+
+		ISelection isel = window.getActivePage().getSelection();
+		if (isel instanceof IStructuredSelection) {
+			IStructuredSelection sel = (IStructuredSelection)isel;
+			Object first = sel.getFirstElement();
+			if (first instanceof Corpus) {
+				corpus = (Corpus)first;
+				if (ParametersDialog.open(this)) {
+					LinkedHashSet<String> formAsLemmaPosSet = new LinkedHashSet<String>();
+					formAsLemmaPosSet.addAll(Arrays.asList(formAsLemmaPosList.split(",")));
+					LinkedHashSet<String> sourcePrioritySet = new LinkedHashSet<String>();
+					if (extrarules != null && extrarules.exists()) sourcePrioritySet.add(EXTRA); // extra must be the first source
+					sourcePrioritySet.addAll(Arrays.asList(sourcePriorityList.split(",")));
+
+					System.out.println("formAsLemmaPosSet="+formAsLemmaPosSet);
+					System.out.println("sourcePrioritySet="+sourcePrioritySet);
+					apply(corpus, dictionary, extrarules, posproperty, lemmaproperty, formAsLemmaPosSet, sourcePrioritySet);
+					return corpus;
+				}
+			}
+		}
+
+		System.out.println("Wrong selection.");
+		return null;
+	}
+
+	public static void apply(final Corpus corpus, final File dictionary, final File extrarules, final String posproperty, 
+			final String targetproperty, final LinkedHashSet<String> formAsLemmaPosList, final LinkedHashSet<String> sourceprioritylist) {
+		final MainCorpus mainCorpus = corpus.getMainCorpus();
+		final File corpusBinaryDirectory = mainCorpus.getBaseDirectory();
+		final File txmDirectory = new File(corpusBinaryDirectory, "txm/"+mainCorpus.getName());
+
+		if (!txmDirectory.exists()) {
+			System.out.println("Can't process a corpus with no XML-TXM files directory: "+txmDirectory);
+			return;
+		}
+
+		final File[] files = txmDirectory.listFiles(new FileFilter() {
+			@Override
+			public boolean accept(File file) {
+				return file.isFile() && file.canWrite() && file.getName().endsWith(".xml");
+			}
+		});
+
+		Property pos = null;
+		try {
+			pos = mainCorpus.getProperty(posproperty);
+		} catch (CqiClientException e1) {
+			// TODO Auto-generated catch block
+			e1.printStackTrace();
+		}
+		if (pos == null) {
+			System.out.println("No pos property found with name="+posproperty);
+			return;
+		}
+
+		if (files == null || files.length == 0) {
+			System.out.println("Can't process a corpus with no XML-TXM files in "+txmDirectory);
+			return;
+		}
+
+		System.out.println("APPLYING : "+dictionary+" to "+mainCorpus+": creating/updating "+targetproperty+ " property with lexicon "+dictionary);
+		JobHandler job = new JobHandler("Creating/Updating "+targetproperty+" property.") {
+			@Override
+			protected IStatus run(IProgressMonitor monitor) {
+				this.runInit(monitor);
+				Tuple t;
+				LinkedHashMap<String, LinkedHashMap<String, LinkedHashMap<String, String>>> rules = new LinkedHashMap<String, LinkedHashMap<String, LinkedHashMap<String, String>>>();
+				HashSet<String> formAsLemmaPosSet = new HashSet<String>();
+				try {
+					// load rules
+					BufferedReader reader = IOUtils.getReader(dictionary);
+					String line = reader.readLine();
+					while (line != null) {
+						String[] splitTab = line.split("\t");
+						if (splitTab.length != 5) {
+							System.out.println("Error in dictionary files with line='"+line+"': length is not 5. Found: "+Arrays.toString(splitTab));
+							line = reader.readLine();
+							reader.close();
+							return Status.CANCEL_STATUS;
+						}
+						String form = splitTab[0];
+						String pos = splitTab[1];//.replace("<no_pos>|", "").replace("|<no_pos>|", "").replace("|<no_pos>", "");
+						String lemma = splitTab[2];//.replace("<no_lemma>|", "").replace("|<no_lemma>|", "").replace("|<no_lemma>", "");
+						String source = splitTab[3];
+						
+						if (! rules.containsKey(form)) rules.put(form, new LinkedHashMap<String, LinkedHashMap<String, String>>());
+						LinkedHashMap<String, LinkedHashMap<String, String>> posHash = rules.get(form);
+						
+						if (!lemma.equals("<no_lemma>")) {
+							if (!posHash.containsKey(pos)) posHash.put(pos, new LinkedHashMap<String, String>());
+							LinkedHashMap<String, String> sourceHash = posHash.get(pos);
+							
+							sourceHash.put(source,  lemma);
+						}
+						line = reader.readLine();
+					}
+					reader.close();
+					System.out.println("Dictionary rules loaded: "+rules.size());
+
+					if (extrarules.exists()) {
+						reader = IOUtils.getReader(extrarules);
+						line = reader.readLine();
+						while (line != null) {
+							String[] splitTab = line.split("\t");
+							if (splitTab.length != 3) {
+								System.out.println("Error in extra rule files with line='"+line+"': length is not 3.");
+								line = reader.readLine();
+								continue;
+							}
+							String form = splitTab[0];
+							String pos = splitTab[1];
+							String lemma = splitTab[2];
+							if (! rules.containsKey(form)) rules.put(form, new LinkedHashMap<String, LinkedHashMap<String, String>>());
+							LinkedHashMap<String, LinkedHashMap<String, String>> posHash = rules.get(form);
+
+							if (!posHash.containsKey(pos)) posHash.put(pos, new LinkedHashMap<String, String>());
+							LinkedHashMap<String, String> sourceHash = posHash.get(pos);
+							sourceHash.put(EXTRA,  lemma);
+
+						}
+						reader.close();
+						System.out.println("Dictionary extra rules loaded: "+rules.size());
+					} else {
+						System.out.println("No extra rule loaded.");
+					}
+					
+					PrintWriter writer = IOUtils.getWriter("/tmp/rules.txt");
+					for (String k : rules.keySet()) {
+						writer.println("FORM="+k);
+						LinkedHashMap<String, LinkedHashMap<String, String>> rules2 = rules.get(k);
+						for (String k2 : rules2.keySet()) {
+							writer.println(" POS="+k2);
+							LinkedHashMap<String, String> rules3 = rules2.get(k2);
+							for (String k3 : rules3.keySet()) {
+								writer.println("  SOURCE="+k3);
+								String ls2 = rules3.get(k3);
+								writer.println("   LEMMA="+ls2);
+							}
+						}
+					}
+					writer.close();
+					System.out.println("RULE DUMP: /tmp/rules.txt");
+					
+					// load rules
+					for (String s : formAsLemmaPosList) {
+						formAsLemmaPosSet.add(s);
+					}
+					System.out.println("POS exception rules loaded: "+formAsLemmaPosSet.size());
+
+					// save previous version of XML-TXM files
+					File previousXMLTXMDirectory = new File(txmDirectory.getAbsolutePath()+"_previous");
+					DeleteDir.deleteDirectory(previousXMLTXMDirectory);
+					FileCopy.copyFiles(txmDirectory, previousXMLTXMDirectory);
+
+					// work
+					File noMatchsFile = new File(TXMPreferences.getString(TBXPreferences.USER_TXM_HOME, TBXPreferences.PREFERENCES_NODE), "results/nomatch.txt");
+					HashSet<String> noMatchsSet = new HashSet<String>();
+					ConsoleProgressBar cpb = new ConsoleProgressBar(files.length);
+					for (File xmlFile : files) {
+						cpb.tick();
+						XMLLemmaProjection p = new XMLLemmaProjection(xmlFile, rules, formAsLemmaPosSet, sourceprioritylist, posproperty, targetproperty);
+						File tmpFile = new File(xmlFile.getParentFile(), "tmp_"+xmlFile.getName());
+						if (p.process(tmpFile)) {
+							if (xmlFile.delete() && tmpFile.renameTo(xmlFile)) {
+								// ok
+							} else {
+								System.out.println("Error during lemma projection: can't replace XML-TXM file: "+xmlFile);
+								return Status.CANCEL_STATUS;
+							}
+						} else {
+							System.out.println("Error during lemma projection. Aborting.");
+							return Status.CANCEL_STATUS;
+						}
+						if (p.getNoMatchValues().size() > 0) {
+							System.out.println("No matchs found with file "+xmlFile.getName()+": "+p.getNoMatchValues());
+							noMatchsSet.addAll(p.getNoMatchValues());
+						}
+					}
+
+					if (noMatchsSet.size() > 0) {
+						System.out.println("Missing lemma values report saved in: "+noMatchsFile);
+						IOUtils.write(noMatchsFile, StringUtils.join(noMatchsSet, "\n"));
+					}
+
+					cpb.done();
+					monitor.worked(50);
+
+					// update corpus
+					// update corpus indexes and edition
+					//					String txmhome = Toolbox.getTXMHOMEPATH();
+					//
+					//					BaseParameters params = corpus.getBase().getBaseParameters();
+					//					params.getKeyValueParameters().put(ImportKeys.MULTITHREAD, "false"); //too soon
+					//					params.getKeyValueParameters().put(ImportKeys.DEBUG, Log.getLevel().intValue() < Level.WARNING.intValue()); // need debug for experimental stuff
+					//					params.getKeyValueParameters().put(ImportKeys.UPDATECORPUS, "true");
+					//
+					//					monitor.setTaskName("Updating corpus");
+					//					File scriptDir = new File(txmhome, "scripts/import");
+					//					File script = new File(scriptDir, "xtzLoader.groovy");
+					//					System.out.println("Updating corpus "+corpus+" using "+params.paramFile);
+					//					boolean ret = ExecuteImportScript.executeScript(script.getAbsolutePath(), params);
+					//					if (!ret) {
+					//						System.out.println("Error during corpus re-import, check the XML-TXM files. Previous version can be restored from "+previousXMLTXMDirectory);
+					//						return Status.CANCEL_STATUS;
+					//					}
+					//					Display.getDefault().syncExec(new Runnable() {
+					//						@Override
+					//						public void run() {CloseEditorsUsing.corpus(corpus);}
+					//					});
+					//					monitor.worked(50);
+
+				} catch (Exception e) {
+					e.printStackTrace();
+					return Status.CANCEL_STATUS;
+				}
+				System.out.println("Done.");
+				return Status.OK_STATUS;
+			}
+		};
+		job.schedule();
+	}
+}

